/*
 * Copyright (c) 1994,1997 by Sun Microsystems, Inc.
 * All rights reserved.
 */

#ifndef _AE_DDICT_H
#define	_AE_DDICT_H

#pragma ident	"@(#)ae_ddict.h	1.4	97/04/04 SMI"

#ifdef	__cplusplus
extern "C" {
#endif

#include 	<sys/dlpi.h>

/* ethernet interfaces (from ethernet.h) */

#define	ETHERADDRL	(6)
#define	ETHERFCSL	(4)	/* ethernet FCS length in octets */

#define	ETHERMTU	(1500)	/* max frame w/o header or fcs */
#define	ETHERMIN	(60)	/* min frame w/header w/o fcs */
#define	ETHERMAX	(1514)	/* max frame w/header w/o fcs */

/*
 * Ethernet address - 6 octets
 */
struct  ether_addr {
	u_char  ether_addr_octet[ETHERADDRL];
};

struct  ether_header {
	struct  ether_addr	ether_dhost;
	struct	ether_addr	ether_shost;
	u_short	ether_type;
};

#define	ETHERTYPE_PUP		(0x0200)	/* PUP protocol */
#define	ETHERTYPE_IP		(0x0800)	/* IP protocol */
#define	ETHERTYPE_ARP		(0x0806)	/* Addr. resolution protocol */
#define	ETHERTYPE_REVARP	(0x8035)	/* Reverse ARP */
#define	ETHERTYPE_MAX		(0xffff)	/* Max valid ethernet type */

#define	ether_copy(a, b) (bcopy((caddr_t)a, (caddr_t)b, 6))
#define	ether_cmp(a, b) (bcmp((caddr_t)a, (caddr_t)b, 6))

/*
 * macros for conversion between host and (internet) network byte order
 */

#if defined(_BIG_ENDIAN) && !defined(ntohl) && !defined(lint)
/* big-endian */
#define	ntohs(x)	(x)
#define	htons(x)	(x)

#elif !defined(ntohl) /* little-endian */

#define	ntohs(n)	(((n&0xff)<<8)|((unsigned short)(n&0xff00)>>8))
#define	htons(n)	(((n&0xff)<<8)|((unsigned short)(n&0xff00)>>8))

#endif

/* vtrace.h */
#define	TRACE_0(fac, tag, name)

#define	TRACE_1(fac, tag, name, d1)

#define	TRACE_2(fac, tag, name, d1, d2)

#define	TRACE_3(fac, tag, name, d1, d2, d3)

#define	TRACE_4(fac, tag, name, d1, d2, d3, d4)

#define	TRACE_5(fac, tag, name, d1, d2, d3, d4, d5)

/* non-DDI interfaces from strsun.h  */

#define	DB_BASE(mp)		((mp)->b_datap->db_base)
#define	DB_LIM(mp)		((mp)->b_datap->db_lim)
#define	DB_REF(mp)		((mp)->b_datap->db_ref)
#define	DB_TYPE(mp)		((mp)->b_datap->db_type)

#define	MBLKL(mp)		((mp)->b_wptr - (mp)->b_rptr)
#define	MBLKSIZE(mp)	((mp)->b_datap->db_lim - (mp)->b_datap->db_base)
#define	MBLKHEAD(mp)	((mp)->b_rptr - (mp)->b_datap->db_base)
#define	MBLKTAIL(mp)	((mp)->b_datap->db_lim - (mp)->b_wptr)

#define	MBLKIN(mp, off, len)	((off <= MBLKL(mp)) && \
	(((mp)->b_rptr + off + len) <= (mp)->b_wptr))

#define	OFFSET(base, p)	((caddr_t)(p) - (caddr_t)(base))

#ifdef	__cplusplus
}
#endif

#endif	/* _AE_DDICT_H */
