
/*
 * Copyright (c) 1995,1997, by Sun Microsystems, Inc.
 * All rights reserved.
 */

#ifndef	_FDISK_H
#define	_FDISK_H

#pragma ident	"@(#)fdisk.h	1.2	97/04/04 SMI"


#ifdef	__cplusplus
extern "C" {
#endif

/*
 * Structure of the physical disk sector 0, allowing multiple
 * OS's to share one disk.  The format of this sector is constrained
 * by BIOS and MS-DOS conventions.
 */

#define	BOOTSZ		446	/* size of boot code in master boot block */
#define	FD_NUMPART	4	/* number of 'partitions' in fdisk table */
#define	MBB_MAGIC	0xAA55	/* magic number for mboot.signature */

/*
 * structure to hold the fdisk partition table
 */
struct ipart {
	u_char	bootid;		/* bootable or not */
	u_char	beghead;	/* beginning head, sector, cylinder */
	u_char	begsect;	/* begcyl is a 10-bit number. High 2 bits */
	u_char	begcyl;		/* are in begsect. */
	u_char	systid;		/* OS type */
	u_char	endhead;	/* ending head, sector, cylinder */
	u_char	endsect;	/* endcyl is a 10-bit number.  High 2 bits */
	u_char	endcyl;		/* are in endsect. */
	long	relsect;	/* first sector relative to start of disk */
	long	numsect;	/* number of sectors in partition */
};


/*
 * master boot block structure
 */
struct mboot {
	char    bootinst[BOOTSZ];
	char    parts[FD_NUMPART * sizeof (struct ipart)];
	ushort   signature;
};


/*
 * bootid
 */
#define	NOTACTIVE	0
#define	ACTIVE		128


/*
 * systid
 */
#define	UNIXOS		99		/* UNIX V.x partition */
#define	SUNIXOS		130		/* Solaris UNIX partition */

#ifdef	__cplusplus
}
#endif

#endif	/* _FDISK_H */
