/*
 * Copyright (c) 1989-1994,1997, by Sun Microsystems, Inc.
 * All rights reserved.
 */

#ifndef _SYS_SCSI_ADAPTERS_ISPCMD_H
#define	_SYS_SCSI_ADAPTERS_ISPCMD_H

#pragma ident	"@(#)ispcmd.h	1.22	97/09/11 SMI"

#include <sys/scsi/scsi_types.h>

#ifdef	__cplusplus
extern "C" {
#endif

#define	PKT2CMD(pkt)		((struct isp_cmd *)(pkt)->pkt_ha_private)
#define	CMD2PKT(sp)		((sp)->cmd_pkt)

/*
 * Per-command ISP private data
 *
 *	- Allocated at same time as scsi_pkt by scsi_hba_pkt_alloc(9E)
 *	- Pointed to by pkt_ha_private field in scsi_pkt
 */
struct isp_cmd {
	struct isp_request	cmd_isp_request;	/* request */
	struct isp_response	cmd_isp_response;	/* response */

	struct scsi_pkt		*cmd_pkt;	/* scsi_pkt reference */
	struct isp_cmd		*cmd_forw;	/* queue link */
	u_long			cmd_dmacount;	/* dma count */
	ddi_dma_handle_t	cmd_dmahandle;	/* dma handle */
	uint_t			cmd_cookie;	/* next cookie */
	uint_t			cmd_ncookies;	/* cookies per window */
	uint_t			cmd_cookiecnt;	/* cookies per sub-win */
	uint_t			cmd_nwin;	/* number of dma windows */
	uint_t			cmd_curwin;	/* current dma window */
	off_t			cmd_dma_offset;	/* current window offset */
	size_t			cmd_dma_len;	/* current window length */
	ddi_dma_cookie_t	cmd_dmacookies[ISP_NDATASEGS];
						/* current dma cookies */
	clock_t			cmd_deadline;	/* cmd completion time */
	u_long			cmd_flags;	/* private flags */
	u_short			cmd_slot;	/* index free slot list */
	u_int			cmd_cdblen;	/* length of cdb */
	u_int			cmd_scblen;	/* length of scb */
};



/*
 * These are the defined flags for this structure.
 */
#define	CFLAG_FINISHED		0x0001	/* command completed */
#define	CFLAG_COMPLETED		0x0002	/* completion routine called */
#define	CFLAG_IN_TRANSPORT	0x0004	/* in use by isp driver */
#define	CFLAG_TRANFLAG		0x000f	/* transport part of flags */
#define	CFLAG_DMAVALID		0x0010	/* dma mapping valid */
#define	CFLAG_DMASEND		0x0020	/* data is going 'out' */
#define	CFLAG_CMDIOPB		0x0040	/* this is an 'iopb' packet */
#define	CFLAG_FREE		0x0080	/* packet is on free list */
#define	CFLAG_DMA_PARTIAL	0x0100	/* partial xfer OK */

#ifdef	__cplusplus
}
#endif

#endif	/* _SYS_SCSI_ADAPTERS_ISPCMD_H */
