/*
 * Copyright 1988-1994,1997, Sun Microsystems, Inc.
 * All rights reserved.
 */

#ifndef	_SYS_P9000IO_H
#define	_SYS_P9000IO_H

#pragma ident	"@(#)p9000io.h	1.3	97/04/07 SMI"

#define	P9000IOC		('F'<<8)
#define	P9000IOGTYPE		(P9000IOC|0)

/*
 * hardware cursor control
 */

struct p9000curpos {
	short x, y;
};

/*
 * Color map I/O.
 */
struct	p9000cmap {
	int		index;		/* first element (0 origin) */
	int		count;		/* number of elements */
	unsigned char	*red;		/* red color map elements */
	unsigned char	*green;		/* green color map elements */
	unsigned char	*blue;		/* blue color map elements */
};

struct p9000cursor {
	short set;		/* what to set */
#define	P9000_CUR_SETCUR	0x01
#define	P9000_CUR_SETPOS	0x02
#define	P9000_CUR_SETHOT	0x04
#define	P9000_CUR_SETCMAP	0x08
#define	P9000_CUR_SETSHAPE 0x10
#define	P9000_CUR_SETALL	0x1F
	short enable;		/* cursor on/off */
	struct p9000curpos pos;	/* cursor position */
	struct p9000curpos hot;	/* cursor hot spot */
	struct p9000cmap cmap;	/* color map info */
	struct p9000curpos size;	/* cursor bit map size */
	char *image;		/* cursor image bits */
	char *mask;		/* cursor mask bits */
};

/* set/get cursor attributes/shape */
#define	P9000IOSCURSOR	(P9000IOC|24)
#define	P9000IOGCURSOR	(P9000IOC|25)

/* set/get cursor position */
#define	P9000IOSCURPOS	(P9000IOC|26)
#define	P9000IOGCURPOS	(P9000IOC|27)

/* get max cursor size */
#define	P9000IOGCURMAX	(P9000IOC|28)

struct p9000_inform {
	u_short	  accessible_width;	/* accessible bytes in scanline */
	u_short	  accessible_height;	/* number of accessible scanlines */
	u_short	  line_bytes;		/* number of bytes/scanline */
	u_short	  hdb_capable;		/* can this thing hardware db? */
	u_short	  vmsize;		/* this is Mb of video memory */
	u_char	  boardrev;		/* board revision # */
	u_char	  slot;			/* sbus slot # */
	u_long	  pad1;			/* expansion */
};

#define	P9000_MON_TYPE_STEREO		0x8	/* stereo display */
#define	P9000_MON_TYPE_0_OFFSET	0x4	/* black level 0 ire instead of 7.5 */
#define	P9000_MON_TYPE_OVERSCAN	0x2	/* overscan */
#define	P9000_MON_TYPE_GRAY	0x1	/* greyscale monitor */

struct p9000_mon_info {
	u_long	  mon_type;		/* bit array: defined above */
	u_long	  pixfreq;		/* pixel frequency in Hz */
	u_long	  hfreq;		/* horizontal freq in Hz */
	u_long	  vfreq;		/* vertical freq in Hz */
	u_long	  vsync;		/* vertical sync in scanlines */
	u_long	  hsync;		/* horizontal sync in pixels */
					/* these are in pixel units */
	u_short	  hfporch;		/* horizontal front porch */
	u_short	  hbporch;		/* horizontal back porch */
	u_short	  vfporch;		/* vertical front porch */
	u_short	  vbporch;		/* vertical back porch */
};

#define	P9000_IDENTIFIER 12	/* accelerated 8bit */

/*
 * Set/Get attributes
 */
#define	P9000_ATTR_NDEVSPECIFIC	8	/* no. of device specific values */
#define	P9000_ATTR_NEMUTYPES	4	/* no. of emulation types */

struct p9000_sattr {
	int	flags;			/* misc flags */
	int	emu_type;		/* emulation type (-1 if unused) */
	int	dev_specific[P9000_ATTR_NDEVSPECIFIC];	/* catchall */
};

struct	p9000_info_more {
	int	fb_type;	/* as defined below */
	int	fb_height;	/* in pixels */
	int	fb_width;	/* in pixels */
	int	fb_depth;	/* bits per pixel */
	int	fb_cmsize;	/* size of color map (entries) */
	int	fb_size;	/* total size in bytes */
};

struct p9000_gattr {
	int	real_type;		/* real device type */
	int	owner;			/* PID of owner, 0 if myself */
	struct p9000_info_more fbtype;	/* fbtype info for real device */
	struct p9000_sattr sattr;		/* see above */
	int	emu_types[P9000_ATTR_NEMUTYPES];	/* possible emulations */
						/* (-1 if unused) */
};

#define	P9000IOSATTR	(P9000IOC|5)
#define	P9000IOGATTR	(P9000IOC|6)

#define	P9000IOPUTCMAP	(P9000IOC|3)
#define	P9000IOGETCMAP	(P9000IOC|4)

/*
 * Video control
 * (the unused bits are reserved for future use)
 */
#define	P9000VIDEO_OFF	0
#define	P9000VIDEO_ON	1

#define	P9000IOSVIDEO	(P9000IOC|7)
#define	P9000IOGVIDEO	(P9000IOC|8)

#define	P9000IOVERTICAL	(P9000IOC|9)

#define	P9000IOGXINFO	(P9000IOC|39)
#define	P9000IOMONINFO	(P9000IOC|40)

#define	P9000IOVRTOFFSET	(P9000IOC|38)


#endif /* _SYS_P9000IO_H */
