
#
#ident	"@(#)Install.sh	1.2	97/04/07 SMI"
#
# Copyright (c) 1995,1997 by Sun Microsystems, Inc.
# All rights reserved.
#
#	Installation script for 'pcepp' PCMCIA sample parallel driver
#
#	copies appropriate pcepp module file to /kernel/drv
#	runs add_drv(1M) to add driver to the system
#	add pcepp entry line in /etc/devlink.tab to create
#		the symbolic link for a pcepp printer in
#		/dev directory (i.e., /dev/printers/pceppS
#		where S represents a PCMCIA socket number)
#
#

DRIVER=pcepp
DST=/kernel/drv
BASE=`uname -p`
DEVLINKTB="/etc/devlink.tab"
TMP=/tmp/$$

#
# add_devlink - adds an entry to ${DEVLINKTB}
#
add_devlink()
{
	PATTERN="$1"
	LINK="$2"

	grep -v "^$PATTERN" ${DEVLINKTB} >$TMP.devlink
	echo "$PATTERN\t$LINK" >>$TMP.devlink
	mv $TMP.devlink ${DEVLINKTB}
}

cp ${BASE}/${DRIVER} ${DST}
add_drv -m '* 0666 bin bin' -i '"pccard,parallel"' ${DRIVER}
add_devlink 'type=ddi_parallel;name=parallel;minor=pcepp' 'printers/pcepp\A0'
devlinks
