
/*
 * Copyright (c) 1992-1997, Sun Microsystems, Inc.  All Rights Reserved.
 * Sun considers its source code as an unpublished, proprietary
 * trade secret, and it is available only under strict license
 * provisions.  This copyright notice is placed here only to protect
 * Sun in the event the source is deemed a published work.
 * Disassembly, decompilation, or other means of reducing the
 * object code to human readable form is prohibited by the license
 * agreement under which this code is provided to the user or
 * company in possession of this copy.
 *
 * RESTRICTED RIGHTS LEGEND: Use, duplication, or disclosure by the
 * Government is subject to restrictions as set forth in
 * subparagraph (c)(1)(ii) of the Rights in Technical Data and
 * Computer Software clause at DFARS 52.227-7013 and in similar
 * clauses in the FAR and NASA FAR Supplement.
 *
 * These examples are provided with no warranties of any kind,
 * including without limitation accuracy and usefulness, and Sun
 * expressly disclaims all implied warranties of merchantability,
 * fitness for a particular purpose and non-infringement. In no
 * event shall Sun be liable for any damages, including without
 * limitation, direct, special, indirect, or consequential damages
 * arising out of, or relating to, use of these examples by customer
 * or any third party. Sun is under no obligation to provide support
 * to customer for this software.
 */

#ifndef	_PIO_REG_H
#define	_PIO_REG_H

#pragma ident	"@(#)pio_reg.h	1.4	97/09/25 SMI"

#ifdef	__cplusplus
extern "C" {
#endif


#ifdef i386
#define	PIO_NAME	"pio"		/* name of the device we support */
#else
#define	PIO_NAME	"SUNW,pio"	/* name string in FCode prom */
#endif

typedef struct pio {				/* per-unit structure */
	dev_info_t		*dip;
	kmutex_t		mutex;
	kcondvar_t		cv;
	int			pio_state;	/* driver state */
	ddi_iblock_cookie_t	iblock_cookie;	/* for mutexes */
	ddi_acc_handle_t	csr_handle;	/* access handle to csr */
	ddi_acc_handle_t	data_handle;	/* access handle to data */
	Pio_csr			*csr;		/* mapped to CSR on device */
	uint8_t			*data;		/* data register on device */
} Pio;

/*
 * pio_state
 */
#define	PIO_OPEN	0x01

#ifndef	TRUE
#define	TRUE	1
#define	FALSE	0
#endif	TRUE

#ifndef	OK
#define	OK	0
#endif	OK

#ifdef	__cplusplus
}
#endif

#endif	/* _PIO_REG_H */
