/*
 * Copyright 1993,1997 by Sun Microsystems, Inc.
 * All rights reserved.
 */

#ifndef	_VIPERREG_H
#define	_VIPERREG_H

#pragma ident	"@(#)viperreg.h	1.6	97/04/07 SMI"

/*
 * The followin describes the viper specific registers
 */

#ifdef	__cplusplus
extern "C" {
#endif

/* Definitions of the vga miscellaneous registers */

#define	VIPER_MISCOUT		0x03c2
#define	VIPER_MISCIN		0x03cc

/* Definitions of the vga sequence registers */

#define	VIPER_SEQ_INDEX_PORT	0x03c4	/* extended ref index */
#define	VIPER_SEQ_DATA_PORT	0x03c5	/* extended regs access here */

/* Viper specific values in the vga miscellaneous register (3cc/3c2) */

#define	VIPER_MISC_VSYNC_POLARITY	0x80
#define	VIPER_MISC_HSYNC_POLARITY	0x40
#define	VIPER_MISC_PAGE_BIT		0x20
#define	VIPER_MISC_DATA			0x08	/* ic designs data bit */
#define	VIPER_MISC_CLOCK		0x04	/* clock bit */
#define	VIPER_MISC_ENABLE_RAM		0x02
#define	VIPER_MISC_IO_ADDR		0x01

/* Viper specific indexes in the vga sequencer register (3c4) */

#define	VIPER_SEQ_CLOCK_INDEX	0x01	/* clock mode reg index */
#define	VIPER_SEQ_MISC_INDEX	0x11	/* misc reg index */
#define	VIPER_SEQ_OUTCTRL_INDEX	0x12	/* output control index */

#define	VIPER_SEQ_MASK		0x0f	/* bits that can be read back */

/* values of the viper miscellaneous sequencer register */

#define	VIPER_CLOCK_SCREEN_OFF	0x20	/* register 3c5, index 1 */

#define	VIPER_MISC_CRLOCK	0x20	/* register 3c5, index 12 */

#define VIPER_OUTCTRL_PVIP_VIDEO_ENABLE    0x10

#ifdef	__cplusplus
}
#endif

#endif	/* !_VIPERREG_H */
